<template>
  <div class="createbuzzcard">
    <Header v-if="isGameStarted()" :title="'Spiel ' + game.name + ' läuft bis ' + gameEndTime" msg="Sobald ein Begriff gefallen ist, klicke auf das entsprechende Feld" :title_right="'Spielcode: ' + game.code" />
    <Header v-if="!isGameStarted()" :title="'Spiel ' + game.name + ' startet am ' + $moment(game.start).format(dateFormat)" msg="Sobald das Spiel begonnen hat, kannst du Felder anklicken" :title_right="'Spielcode: ' + game.code" />
    <CardGrid v-if="!ifWinner()" :cards="game.cards" :size="gamesize" :editable="editable" :countable="countable" @counted="counted"/>
    <div class="container">
        <div class="justify-content-center">
            <div  v-if="ifWinner() && !iAmWinner()" >
                <p class="display-3"><strong>Winner is: {{ game.winner }}</strong></p>
                <p class="display-4">You Loose!</p>
            </div>
            <h2 v-if="ifWinner() && iAmWinner()"  class="display-3">You Win!</h2>
        </div>
    </div>
  </div>
</template>

<script>
// @ is an alias to /src
import CardGrid from "@/components/CardGrid.vue";
import Header from "@/components/Header.vue";
import {GAME_LEVEL} from "@/constants/game-level";
import { mapState, mapActions } from 'vuex';

export default {
    name: "playGame",
    components: {
        Header,
        CardGrid
    },
    data() {
        return {
            editable: false,
            countable: true,
            gamesize: 3,
            gameEndTime: "",
            dateFormat: 'LLL',
            timer: null,
        };
    },
    mounted () {
        this.init()
    },
    methods: {
        ...mapActions (['hitBuzzword']),
        init: function() {
            this.gamesize = this.getGameSize()
            this.gameEndTime = this.calculateEndTime()
            this.checkForGameStart()
        },
        getGameSize: function() {
            if (this.game.level === GAME_LEVEL.EASY) {
                return 3
            }
            else if (this.game.level === GAME_LEVEL.MEDIUM) {
                return 4
            }
            else if (this.game.level === GAME_LEVEL.HEAVY) {
                return 5
            }
        },
        calculateEndTime: function() {
            return this.$moment(this.game.start).add(this.game.duration, 's').format(this.dateFormat)
        },
        setupTimer: function() {
            this.timer = setTimeout(() => this.checkForGameStart(), 2000)
        },
        checkForGameStart: function() {
            this.countable = this.isGameStarted()
            this.setupTimer()
        },
        isGameStarted: function() {
            if (this.$moment(this.game.start) < this.$moment()){
                return true
            }
            return false
        },
        counted: function(event) {
            event.xPosition = event.x;
            event.yPosition = event.y
            this.hitBuzzword(event).then(res => {
                
                }).catch(err => {
                    if (this.$store.state.errors.length >= 1) {
                        let errorMsg = this.$store.state.errors[0]
                        alert(errorMsg)
                        this.$store.state.errors = null
                    }
                })
        },
        iAmWinner: function() {
            let nickName = this.game.nickName;
            if (nickName == this.game.winner){
                this.$confetti.start();
                return true;
            }
            else{
                return false;
            }
        },
        ifWinner: function() {
            return this.game.winner != null && this.game.winner != "";
        }
    },
    computed: {
        ...mapState ({
            game: state => state.game,
        }),
    },
};
</script>

<style scoped>
.submit-button {
    margin-left: 1rem;
}
</style>
